#include <u.h>
#include <libc.h>
#include <auth.h>
#include <fcall.h>
#include <thread.h>
#include "layer.h"
#include "dat.h"
#include "fns.h"

// read 9P messages from v->fd, convert to r's Fcall struct, send r down
// v->c
void
read9psrv(void *v)
{
	int n;
	char *buf = nil;
	Readarg *a = v;
	Req *r = nil;

	for (; ; ) {
		if (buf == nil)
			buf = emalloc(MAXMSG+MAXFDATA);
		if (r == nil)
			r = newreq(nil, 0);
		if ((n = read9p(a->fd, buf, MAXMSG+MAXFDATA)) <= 0) {
			sendp(a->c, nil);
			break;
		}
		if (convM2S(buf, &r->Fcall, n) != n) {
			threadprint(2, "warning: bad message\n");
			continue;
		}
		r->buf = buf;
		sendp(a->c, r);
		buf = nil;
		r = nil;
	}
	free(buf);
	donereq(r);
	threadexits(nil);
}
