#include	"mk.h"

/* table-driven version in bootes dump of 12/31/96 */

/*
 * layers.c needs more information than just mtime about each file.
 * let's try not to stat the file for every bit of metadata.
 */
long
mtime(char *name)
{
	Dir sbuf;

	if(mkdirstat(name, &sbuf) < 0)
		return 0;
	/* cache metadata in the symbol table */
	symlook(name, S_TIME, (void *)sbuf.mtime);
	symlook(strdup(name), S_LAYERS,
		(void *)newlayer((Fsinst){sbuf.type, sbuf.dev, sbuf.qid}));
	return sbuf.mtime;
}

long
timeof(char *name, int force)
{
	Symtab *sym;

	if(utfrune(name, '('))
		return atimeof(force, name);		/* archive */

	if(force)
		return mtime(name);

	sym = symlook(name, S_TIME, 0);
	if (sym)
		return (long) sym->value;		/* uggh */
	return mtime(name);
}

void
touch(char *name)
{
	Bprint(&bout, "touch(%s)\n", name);
	if(nflag)
		return;

	if(utfrune(name, '('))
		atouch(name);		/* archive */
	else if(chgtime(name) < 0) {
		perror(name);
		Exit();
	}
}

void
delete(char *name)
{
	if(utfrune(name, '(') == 0) {		/* file */
		if(remove(name) < 0)
			perror(name);
	} else
		fprint(2, "hoon off; mk can'tdelete archive members\n");
}

void
timeinit(char *s)
{
	long t;
	char *cp;
	Rune r;
	int c, n;

	t = time(0);
	while (*s) {
		cp = s;
		do{
			n = chartorune(&r, s);
			if (r == ' ' || r == ',' || r == '\n')
				break;
			s += n;
		} while(*s);
		c = *s;
		*s = 0;
		symlook(strdup(cp), S_TIME, (void *)t)->value = (void *)t;
		if (c)
			*s++ = c;
		while(*s){
			n = chartorune(&r, s);
			if(r != ' ' && r != ',' && r != '\n')
				break;
			s += n;
		}
	}
}
